#! /usr/bin/env lua

require("lobj")

local strup, strdown = lobj.UTF8.strup, lobj.UTF8.strdown
local validate, normalize = lobj.UTF8.validate, lobj.UTF8.normalize
local ALL = lobj.NORMALIZE_ALL

local msg = "Hello sad³²³sßæðßæ®³®³¢↓e Á World!"
print("Message: ", msg)
print("Valid UTF8?", validate(msg)) 
print("Up:", strup(msg)) 
print("Down:", strdown(msg))
print("Equal?", normalize(strup(strdown(msg)), ALL) == normalize(strup(msg), ALL))

local filename = "/usr/bin/lua"
print("Filename:", lobj.UTF8.fromFilename(filename))

local orig = normalize("This is my message! éçè", ALL)
local res = lobj.convert(orig, "UTF8", "ISO-8859-1")
print("Conversion?", normalize(lobj.convert(res, "ISO-8859-1", "UTF8"), ALL) == orig)
